import "./style.css";
import { reactive as N, ref as j, watchEffect as x, onActivated as B, nextTick as D, onBeforeUnmount as P, resolveComponent as p, openBlock as I, createElementBlock as T, createElementVNode as l, createVNode as h, withCtx as F, withDirectives as O, vShow as W, pushScopeId as A, popScopeId as U } from "vue";
import { Button as V } from "@opentiny/vue";
import { VueMonaco as H, CloseIcon as J, LinkButton as z } from "@opentiny/tiny-engine-common";
import { useModal as R, useCanvas as M, useNotify as Y, useHelp as q } from "@opentiny/tiny-engine-controller";
import { initCompletion as G } from "@opentiny/tiny-engine-common/js/completion";
import { lint as K, initLinter as Q } from "@opentiny/tiny-engine-common/js/linter";
import { theme as X } from "@opentiny/tiny-engine-controller/adapter";
import { insertName as Z, string2Ast as E, formatString as $, ast2String as tt } from "@opentiny/tiny-engine-common/js/ast";
import { constants as et } from "@opentiny/tiny-engine-utils";
import { getSchema as y } from "@opentiny/tiny-engine-canvas";
import { isFunction as ot } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: nt } = et, { message: st, confirm: rt } = R(), s = N({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null
}), a = j(null);
let f = null;
const g = () => {
  var e;
  const t = ((e = y) == null ? void 0 : e()) || {};
  return t.methods = (t == null ? void 0 : t.methods) || {}, t.methods;
}, it = () => M().pageState.pageSchema && Object.keys(g()) || [], S = () => {
  const e = Object.entries(g()).map(([o, n]) => Z(o, n.value)).join(`
`);
  return f = E(e), e;
}, ct = (t) => {
  if (s.isChanged = t !== s.script, !a.value)
    return;
  const e = a.value.getEditor().getModel();
  K(e, s.linterWorker);
}, b = ({ name: t, content: e }) => {
  if (!t)
    return;
  const o = g();
  o[t] || (o[t] = {
    type: nt.JSFunction,
    value: ""
  }), o[t].value = e;
}, k = () => {
  if (!s.isChanged)
    return !1;
  if (s.hasError)
    return st({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const t = a.value.getEditor().getValue(), e = E(t);
  return y().methods = {}, e.program.body.forEach((o, n) => {
    var d, u;
    const r = (d = o == null ? void 0 : o.id) == null ? void 0 : d.name;
    (u = e.program.body[n + 1]) != null && u.leadingComments && o.trailingComments === e.program.body[n + 1].leadingComments && delete o.trailingComments;
    const i = $(tt(o).trim(), "javascript");
    b({ name: r, content: i });
  }), M().setSaved(!1), s.isChanged = !1, Y({
    type: "success",
    message: "保存成功！"
  }), !0;
}, lt = (t) => (e) => {
  const o = ot(e) ? e : () => t("close");
  if (!s.isChanged) {
    o(!0);
    return;
  }
  rt({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      o(k());
    },
    cancel() {
      o(!0);
    }
  });
}, at = () => {
  if (!s.editorSelection || !a.value)
    return;
  const t = a.value.getEditor();
  t.setSelection(s.editorSelection), t.focus();
  const e = t.getTopForLineNumber(s.editorSelection.startLineNumber - 1);
  t.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: e
    },
    0
  );
}, dt = (t) => {
  var n;
  if (!t)
    return;
  const e = f == null ? void 0 : f.program.body.filter((r) => {
    var i;
    return t === ((i = r == null ? void 0 : r.id) == null ? void 0 : i.name);
  });
  if (e.length === 0)
    return;
  const o = (n = e[0]) == null ? void 0 : n.loc;
  o && (s.editorSelection = {
    startColumn: o.start.column,
    startLineNumber: o.start.line,
    endColumn: o.end.column + 1,
    endLineNumber: o.end.line
  }), s.editorSelection && at();
}, ut = ({ emit: t }) => (x(() => {
  s.script = S();
}), B(() => {
  D(() => {
    var e;
    s.script = S(), (e = a.value) == null || e.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: s,
  monaco: a,
  change: ct,
  saveMethods: k,
  close: lt(t)
});
const mt = (t, e) => {
  const o = t.__vccOpts || t;
  for (const [n, r] of e)
    o[n] = r;
  return o;
}, pt = {
  saveMethod: b,
  highlightMethod: dt,
  getMethodNameList: it,
  getMethods: g
}, ht = {
  components: {
    MonacoEditor: H,
    TinyButton: V,
    CloseIcon: J,
    LinkButton: z
  },
  emits: ["close"],
  setup(t, { emit: e }) {
    const o = q().getDocsUrl("script"), { state: n, monaco: r, change: i, close: d, saveMethods: u } = ut({ emit: e }), _ = {
      roundedSelection: !0,
      automaticLayout: !0,
      autoIndent: !0,
      language: "javascript",
      formatOnPaste: !0,
      tabSize: 2,
      theme: X(),
      minimap: {
        enabled: !1
      },
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, v = (m) => {
      var c;
      r.value && (n.completionProvider = G(r.value.getMonaco(), (c = r.value.getEditor()) == null ? void 0 : c.getModel()), n.linterWorker = Q(m, r.value.getMonaco(), n));
    };
    return P(() => {
      var m, c, C;
      (m = n.completionProvider) == null || m.forEach((w) => {
        w.dispose();
      }), (C = (c = n.linterWorker) == null ? void 0 : c.terminate) == null || C.call(c);
    }), {
      state: n,
      monaco: r,
      options: _,
      close: d,
      change: i,
      saveMethods: u,
      editorDidMount: v,
      docsUrl: o
    };
  }
}, L = (t) => (A("data-v-2ed647a3"), t = t(), U(), t), ft = { class: "plugin-page-js-container" }, gt = { class: "code-edit-head" }, _t = { class: "head-left" }, vt = /* @__PURE__ */ L(() => /* @__PURE__ */ l("span", { class: "title" }, "页面 JS", -1)), Ct = { class: "head-right" }, St = /* @__PURE__ */ L(() => /* @__PURE__ */ l("span", null, "保存", -1)), Mt = { class: "dots" }, Et = { class: "code-edit-content" };
function yt(t, e, o, n, r, i) {
  const d = p("link-button"), u = p("tiny-button"), _ = p("close-icon"), v = p("monaco-editor");
  return I(), T("div", ft, [
    l("div", gt, [
      l("div", _t, [
        vt,
        h(d, { href: n.docsUrl }, null, 8, ["href"])
      ]),
      l("div", Ct, [
        h(u, {
          type: "primary",
          class: "save-btn",
          onClick: n.saveMethods
        }, {
          default: F(() => [
            St,
            O(l("span", Mt, null, 512), [
              [W, n.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        h(_, { onClose: n.close }, null, 8, ["onClose"])
      ])
    ]),
    l("div", Et, [
      h(v, {
        ref: "monaco",
        value: n.state.script,
        options: n.options,
        onChange: n.change,
        onEditorDidMount: n.editorDidMount
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount"])
    ])
  ]);
}
const bt = /* @__PURE__ */ mt(ht, [["render", yt], ["__scopeId", "data-v-2ed647a3"]]), Ot = {
  id: "PageController",
  title: "页面 JS",
  icon: "plugin-icon-js",
  align: "top",
  api: pt,
  component: bt,
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
};
export {
  Ot as default
};
